/*
 * Project: MoleCuilder
 * Description: creates and alters molecular systems
 * Copyright (C)  2012 University of Bonn. All rights reserved.
 * Copyright (C)  2013 Frederik Heber. All rights reserved.
 * 
 *
 *   This file is part of MoleCuilder.
 *
 *    MoleCuilder is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MoleCuilder is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * AtomObserver.cpp
 *
 *  Created on: Nov 30, 2011
 *      Author: heber
 */

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

//#include "CodePatterns/MemDebug.hpp"

#include <boost/assign.hpp>

#include "CodePatterns/Singleton_impl.hpp"

#include "Atom/atom_observable.hpp"

#include "AtomObserver.hpp"

using namespace boost::assign;

static const Observable::channels_t getAtomChannels()
{
  Observable::channels_t channels;
  for (int i=0;i<AtomObservable::NotificationType_MAX; ++i)
    channels += (enum AtomObservable::NotificationType)i;
  return channels;
}

const Observable::channels_t AtomObserver::AtomChannels(getAtomChannels());

AtomObserver::AtomObserver() :
    EntityObserver<atom>(AtomChannels, std::string("AtomObserver"))
{}

CONSTRUCT_SINGLETON(AtomObserver)
