/*
 * Project: MoleCuilder
 * Description: creates and alters molecular systems
 * Copyright (C)  2010-2012 University of Bonn. All rights reserved.
 * 
 *
 *   This file is part of MoleCuilder.
 *
 *    MoleCuilder is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MoleCuilder is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * TesselPoint.cpp
 *
 *  Created on: Jul 30, 2010
 *      Author: heber
 */

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

//#include "CodePatterns/MemDebug.hpp"

#include "CodePatterns/Log.hpp"

#include "Atom/TesselPoint.hpp"

#include <iostream>


/** Constructor of class TesselPoint.
 */
TesselPoint::TesselPoint()
{};

/** Destructor for class TesselPoint.
 */
TesselPoint::~TesselPoint()
{};

void TesselPoint::UpdateStep(const unsigned int _step)
{
  ASSERT(0, "TesselPoint::UpdateStep() should never be called, TesselPoints don't have trajectories.");
  AtomInfo::AppendTrajectoryStep(_step);
};

void TesselPoint::removeStep(const unsigned int _step)
{
  ASSERT(0, "TesselPoint::removeStep() should never be called, TesselPoints don't have trajectories.");
  AtomInfo::removeTrajectoryStep(_step);
};

TesselPoint * TesselPoint::getTesselPoint()
{
  return this;
}

std::ostream & TesselPoint::operator << (std::ostream &ost) const
{
  ParticleInfo::operator<<(ost);
  ost << "," << getPosition();
  return ost;
}

std::ostream & operator << (std::ostream &ost, const TesselPoint &a)
{
  a.ParticleInfo::operator<<(ost);
  ost << "," << a.getPosition();
  return ost;
}

